
// SUJESTOES:
/*
Usar pin


*/

/*  jQuery.ma.mapa  v1.5  */
(function ($, window, document) {

    // Fix para versoes de Jquery mais antigas
    var temOn = jQuery.fn.on;
    jQuery.fn.on = function (types, selector, data, fn) {
        if (temOn) {
            return temOn.apply(this, arguments);
        }
        jQuery(selector).live(types, data, fn);
        return this;

    }


    "use strict";
    // Create the defaults once
    var pluginName = "maMapa",
        defaults = {
            mapa: true,
            direccoes: true,
            altura: '100',
            largura: '100',
            directionsboxID: 'directionsboxMA',
            directionsID: 'directionsMA',
            imgFolder: '/images/mapa',
			pinsDiferentes: true,
            abrePopups: true,
			pinCenterPosition: [0,0],
            textos: {
                procurar: 'Local onde se encontra',
                origem: 'Origem',
                destino: 'Destino',
                botao: 'Procurar',
                definirdestino: 'Definir como destino',
                naoencontrou: 'N&atilde;o foram encontrados caminhos',
                infoTrajecto: '',
                distancia: 'Dist&acirc;ncia',
                duracao: 'Tempo'
            },
            rotaOptions: {
                corlinha: '#2A4C43'
            },
            mapOptions: {
                center: new google.maps.LatLng(0, 0),
                zoom: 13,
                mapTypeId: google.maps.MapTypeId.ROADMAP,
                mapTypeControl: true,
                mapTypeControlOptions: {},
                panControl: true,
                panControlOptions: {},
                zoomControl: true,
                zoomControlOptions: {},
                streetViewControl: false,
                scrollwheel: true,
                disableDefaultUI: false,
                minZoom: 0,
                maxZoom: 20,
				styles:[
					{
						featureType: "poi",
						elementType: "labels",
						stylers: [
							  { visibility: "off" }
						]
					}
				]
            },
            marcadores: []
        },
        self = null,
		openPop = function(){};

    function Plugin(element, options) {
        self = this;
        self.element = $(element);
		
        self.options = $.extend(true, defaults, options);
        self._defaults = defaults;
        self._name = pluginName;

        self.map = null;
        self.vars = {
            directionsService: new google.maps.DirectionsService(),
            map: null,
            marcadores_activos: [],
            limites: new google.maps.LatLngBounds(),
            infowindow: new google.maps.InfoWindow(),
            caminho: []
        };

        self.init();
    }

    Plugin.prototype = {

        init: function () {
            if (typeof google === "undefined") {
                self.log("Falta o script do google");
                return;
            }
            if (self.options.mapa) {

                self.mapContainer = $('<div class="mapaMA" />');
				self.element.append( self.mapContainer);
				
                //define o tamanho do componente todo
                self.element.css("width", self.options.largura);
                self.element.height("100%");

                //define o tamanho do mapa
                self.mapContainer.css("height", self.options.altura);
                self.mapContainer.width("100%");

                self.map = new google.maps.Map(self.mapContainer[0], self.options.mapOptions);
            }

            if (self.options.direccoes) {
               self._createControls();
            }
			
			if(!self.options.marcadores.lat){
				var i = 0,
					marcTam = self.options.marcadores.length,
					coords=null;
		  
				for (i = 0; i < marcTam; i++) {
					coords = self.options.marcadores[i].coords.replace("(","").replace(")","").split(",");
					
					 self.options.marcadores[i].lat=coords[0];
					 self.options.marcadores[i].lng=coords[1];
				}
			}			

            if (self.options.marcadores.length > 0) {
               self._criaMarcadores();
            }
			
			
        },
        _createControls: function () {

            if (self.options.directionsboxID === 'directionsboxMA') {
                $(self.element[0]).append('<div id="directionsboxMA"></div>');
            }

            if (self.options.directionsID === 'directionsMA') {
                $(self.element[0]).append('<div id="directionsMA"></div>');
            }

            $("#" + self.options.directionsboxID).append('<div id="directions-sel-MA"></div>');
            $("#directions-sel-MA").append('<div id="origem-mapa-MA"><input id="origemMAPA" class="input-map-MA" type="text" placeholder="' + self.options.textos.procurar + '" name="origem"></div>');

            if (self.options.marcadores.length > 1) {
                $("#directions-sel-MA").append('<div id="destino-mapa-MA"><select id="destinoMAPA"></select></div>');
            }

            $("#directions-sel-MA").append('<div id="botao-mapa-MA" style="cursor:pointer; cursor:hand;">' + self.options.textos.botao + '</div>');

            $("#botao-mapa-MA").click(function () {
              if ($("#origemMAPA").val() !== "" && $("#origemMAPA").val() !== self.options.textos.procurar) 
				{
                    self._criaRota();
					 $(".vazio").hide();
                }
				 else
                { $("#origem-mapa-MA").append('<div class="vazio">*</div>');}
            });

            $("#origemMAPA").keypress(function (e) {
                if ((e.which && e.which === 13) || (e.keyCode && e.keyCode === 13)) {
                    $("#botao-mapa-MA").click();
                    return false;
                } else {
                    return true;
                }
            });

			$(document).on("click", "#options-mapa-print-MA", function () {

				var mywindow = window.open('', 'PrintRota', 'height=600,width=540,scrollbars=1,location=0,status=0,menubar=0');
				mywindow.document.write('<html><head><title>Print Directions</title>');
				mywindow.document.write('<link rel="stylesheet" href="/css/jquery.ma.mapa.css" type="text/css" />');
				mywindow.document.write('<style>body{font-size:12px; font-family:arial} #options-mapa-print-MA,#options-mapa-close-MA{display:none!important}</style>');
				mywindow.document.write('</head><body ><a onclick="print();"><img src="'+self.options.imgFolder+'/imprimir.png"/></a>');
				mywindow.document.write($("#" + self.options.directionsID).html());
				mywindow.document.write('</body></html>');
				mywindow.document.close();
				mywindow.print();
			});
            
            $(document).on("click", "#options-mapa-close-MA", function () {
                self._reset();
                self._criaMarcadores();
            });

           openPop= function (val){
				$("#destinoMAPA").val(val);
			}
        },

        _reset: function () {
            var h = self.vars.marcadores_activos.length - 1;
            for (h; h >= 0; h--) {
                self.vars.marcadores_activos[h].marker.setMap(null);
            }
  
            self.apagaRota();
            self.vars.marcadores_activos = [];
            self.vars.limites = new google.maps.LatLngBounds();

            $("#options-mapa-close-MA").hide();
            $("#options-mapa-print-MA").hide();
            $("#dir_erro").hide();
        },

        /* --- INICIO DAS FUNCOES DOS MARCADORES --- */
        _criaMarcadores: function () {


            var op = "",
                i = 0,
                marcTam = self.options.marcadores.length,
                marcador;

            for (i = 0; i < marcTam; i++) {
                marcador = self.options.marcadores[i];
                self._adicionaMarcador(marcador);
                op += '<option value="' + marcador.id + '">' + marcador.titulo + '</option>';
            }
            if (self.options.mapa) {
                if (self.options.marcadores.length === 1) {
                    self.map.panTo(new google.maps.LatLng(self.options.marcadores[0].lat, self.options.marcadores[0].lng));
                } else {
                    self.map.fitBounds(self.vars.limites);
                }
            }
            if (self.options.marcadores.length > 1) {
                $("#destinoMAPA").html(op);
            }

        },
        //ADICIONA UM DETERMINADO MARCADOR
        _adicionaMarcador: function (marcador) {

            var marker = self._constroiMarcador(new google.maps.LatLng(marcador.lat, marcador.lng), marcador.titulo, marcador.id);
            if (self.options.abrePopups) {
                self.adicionaListenerMarcador(marker, marcador);
            }
        },
        //CONSTROI O MARCADOR
        _constroiMarcador: function (point, titulo, id) {

            var pin = self.getPinImg(id),
                marker = new google.maps.Marker({
                    position: point,
                    icon: pin,
                    map: self.map,
                    clickable:self.options.abrePopups,
                    title: titulo //,
                    //  animation: google.maps.Animation.DROP
                });

            self.vars.limites.extend(marker.getPosition());
			self.vars.marcadores_activos.push({ "id": id,"marker": marker});
			
            return marker;
        },
        //DEVOLVE O ICON DO MARCADOR CONSOANTE O ID
        getPinImg: function (id) {
            if (!self.options.pinsDiferentes && id) {
                id = 0;
            }
            if (id === undefined) {
                id = "origem";
            }
			if(this.options.pinCenterPosition[0]>0){
					return new google.maps.MarkerImage(this.options.imgFolder + '/pin_' + id + '.png', null, null, new google.maps.Point(this.options.pinCenterPosition[0], this.options.pinCenterPosition[1]));
			}else{
				return new google.maps.MarkerImage(this.options.imgFolder + '/pin_' + id + '.png');
			}
        },
       
        /* ADICIONA OS LISTENERS A CADA MARKER */
        adicionaListenerMarcador: function (marker, marcador) {


            google.maps.event.addListener(marker, 'click', (function (marker, marcador) {
                return function () {
                    self.vars.infowindow.close();
                    var frame = '<div id="popup-mapa-MA">' + marcador.conteudo + '</div>';

                    if (self.options.marcadores.length > 1 && self.options.direccoes) {
                        frame += '<p class="clicapop" value="' + marcador.id + '">' + self.options.textos.definirdestino + '  <img src="'+self.options.imgFolder+'/pin_0.png" alt="" width="12px" height="16px" style="border:0px;vertical-align:middle;padding-bottom:3px;" /></p>';
                    }
                    self.vars.infowindow.setContent(frame);
                    self.vars.infowindow.open(self.map, this);
                };
            }(marker, marcador)));

        },

        /*-----   INICIO DAS FUNCOES DAS ROTAS     --------------------------------*/
        _criaRota: function () {

            var origem = $("#origemMAPA").val(),
                i = 0,
                marcTam = self.options.marcadores.length,
                id_dest = 0,
                destino,
                request = {};

            if (marcTam > 1) {

                for (i = 0; i < marcTam; i++) {
                    if (self.options.marcadores[i].id === parseInt($("#destinoMAPA").val(),10)) {
                        id_dest = i;
                    }
                }
            } else {
                id_dest = 0;
            }
            destino = new google.maps.LatLng(self.options.marcadores[id_dest].lat, self.options.marcadores[id_dest].lng);

            if (origem !== "") {
                request = {
                    origin: origem,
                    destination: destino,
                    travelMode: google.maps.DirectionsTravelMode.DRIVING
                };

                self.vars.directionsService.route(request, function (response, status) {
                    if (status === google.maps.DirectionsStatus.OK) {

                        self._reset();

                        var instrucoes = '',
                            legs = response.routes[0].legs,
                            legsTam = legs.length,
                            fim,
                            polylineOptions,
                            steps,
                            step = 0,
                            linha,
                            k = 0;
                        for (i = 0; i < legsTam; i++) {
                            steps = legs[i].steps;
                            for (step = 0; step < steps.length; step++) {
                                polylineOptions = {
                                    map: self.map,
                                    strokeColor: self.options.rotaOptions.corlinha,
                                    strokeOpacity: 0.8,
                                    strokeWeight: 4,
                                    clickable:false,
                                    path: steps[step].lat_lngs
                                };
                                fim = steps[step].end_location;
                                linha = new google.maps.Polyline(polylineOptions);
                                self.vars.caminho.push(linha);
                            }

                            instrucoes = "";
                            instrucoes += "<div id='directions-topo-mapaMA'><img src='" + self.options.imgFolder + "/pin_origem.png' height=26 width=20 style='vertical-align:middle; padding-right:10px'/>" + legs[i].start_address + "</div>";
                            instrucoes += "<div id='directions-meio-mapaMA'>";

                            instrucoes += "<div class='d_linha header'>";
                            instrucoes += "<div class='d_id'>&nbsp;</div>";
                            instrucoes += "<div class='d_desc'>" + self.options.textos.infoTrajecto + " </div>";
                            instrucoes += "<div class='d_dist'><b>" + self.options.textos.distancia + ":</b> " + legs[i].distance.text + " <b>" + self.options.textos.duracao + ":</b> " + legs[i].duration.text + "</div>";
                            instrucoes += "</div>";



                            for (k = 0; k < legs[i].steps.length; k++) {
                                instrucoes += "<div class='d_linha'>";
                                instrucoes += "<div class='d_id'>" + (k + 1) + "</div>";
                                instrucoes += "<div class='d_desc'>" + legs[i].steps[k].instructions + "</div>";
                                instrucoes += "<div class='d_dist'>" + legs[i].steps[k].distance.text + "</div>";
                                instrucoes += "</div>";
                            }

                            instrucoes += "</div>";
                            instrucoes += "<div id='directions-fundo-mapaMA'><img src='" + self.options.imgFolder + "/pin_0.png' height=26 width=20 style='vertical-align:middle; padding-right:10px'/>" + legs[i].end_address + " - " + self.options.marcadores[id_dest].titulo + "</div>";
                        }

                        $("#" + self.options.directionsID).append(instrucoes);

                        $("#directions-topo-mapaMA").append('<div id="options-mapa-MA" style="cursor:pointer;cursor:hand;"></div<');

                        
						$("#options-mapa-MA").append('<div id="options-mapa-print-MA"><img src="' + self.options.imgFolder + '/imprimir.png" style="vertical-align:middle" border="0" alt="" /></div>');
                       

                        $("#options-mapa-MA").append('<div id="options-mapa-close-MA"><img src="' + self.options.imgFolder + '/fechar.png" style="vertical-align:middle" border="0" alt="" /></div>');

                        if (self.options.mapa) {
                            self._constroiMarcador(response.routes[0].legs[0].steps[0].start_location, self.options.textos.origem);
                            self._constroiMarcador(fim, self.options.marcadores[id_dest].titulo, 0);

                            self.map.fitBounds(self.vars.limites);
                        }
                        $("#options-mapa-close-MA").show();
                        $("#options-mapa-print-MA").show();
                    } else {

                        if ($("#dir_erro").length === 0) {
                            $("#" + self.options.directionsID).append('<div id="dir_erro" style="clear:both;padding-top:5px; padding-left:5px;padding-bottom:5px;">' + self.options.textos.naoencontrou + '</div>');
                        } else {
                            $("#dir_erro").html(self.options.textos.naoencontrou);
                        }

                    }
                });
            } else {
                //alert('Campo de origem inválido.');
            }
        },
        //APAGA DETERMINADA ROTA DO MAPA
        apagaRota: function () {
            var c = 0;
            for (c = 0; c < self.vars.caminho.length; c++) {
                self.vars.caminho[c].setMap(null);
            }
            self.vars.caminho = [];

            $("#" + self.options.directionsID).html("");
        },
        log: function (conteudo) {
            //console.log(window.location.hostname);
            console.log(conteudo);
        }
    };

    // A really lightweight plugin wrapper around the constructor,
    // preventing against multiple instantiations
    $.fn[pluginName] = function (options) {
        return this.each(function () {
				
            if (!$.data(this, "plugin_" + pluginName)) {
                $.data(this, "plugin_" + pluginName,
                    new Plugin(this, options));
            }
        });
    };

}(jQuery, window, document));